{ pkgs ? import <nixpkgs> { }, self }:
with pkgs;
let
    version = "0.0.1";
    deps = [
        gst_all_1.gstreamer
        gst_all_1.gstreamer.dev
        gst_all_1.gst-plugins-base
        gst_all_1.gst-plugins-good
        gst_all_1.gst-plugins-bad
        gst_all_1.gst-plugins-ugly
        protoc-gen-go
    ];
    nativeDeps = [
        gcc
        pkg-config
    ];
in
pkgs.buildGo120Module {
  pname = "gstreamer-grafix";
  inherit version;

  src = self;

  buildInputs = [
    stdenv
  ] ++deps;
  nativeBuildInputs = [
  ] ++nativeDeps;

  tags = [ ];

  ldflags = [
    "-s" "-w"
  ];


  #vendorSha256 = lib.fakeSha256;
  vendorSha256 = "sha256-tXSUljm4ijX2PPIKimIU6hc2cwsCwdnVjgPvjCv12F0=";

}